library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity top is
	port (
		clk : in std_logic;
		cnt_out : out std_logic_vector(0 to 3));
end top;

architecture Behavioral of top is
	signal rst_cnt: std_logic_vector(0 to 15) := x"0000";
	signal cnt : std_logic_vector(0 to 15);
	signal rst : std_logic;
begin
	rst <= rst_cnt(0);
	generate_rst_process : process(clk)
	begin
		if clk'event and clk = '1' then
			if rst_cnt(0) = '0' then
				rst_cnt <= rst_cnt + 1;
			end if;
		end if;
	end process generate_rst_process;

	cnt_out <= cnt(0 to 3);
	process(clk)
	begin
		if clk'event and clk = '1' then
			if rst = '0' then
				cnt <= (others => '0');
			else
				cnt <= cnt + 1;
			end if;
		end if;
	end process;
end Behavioral;
