LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY tb_uart_rx IS
END tb_uart_rx;
 
ARCHITECTURE behavior OF tb_uart_rx IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT uart_rx
    PORT(
         clk : IN  std_logic;
         rst : IN  std_logic;
         rx : IN  std_logic;
         rx_data : OUT  std_logic_vector(7 downto 0));
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal rst : std_logic := '0';
   signal rx : std_logic := '1';

 	--Outputs
   signal rx_data : std_logic_vector(7 downto 0);

BEGIN

	clk <= not clk after 5 ns;
	rst <= '1' after 100 ns;

	process
	begin
		wait for 114000 ns;
		--
		rx <= '0'; wait for 104000 ns; -- start
		rx <= '1'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '0'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '0'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '0'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '0'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '1'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '1'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '0'; wait for 104000 ns; -- ascii A, 61, 
		rx <= '1'; wait for 104000 ns; -- stop 
		rx <= '1'; wait for 104000 ns; -- stop 
	--
		rx <= '0'; wait for 104000 ns; -- start
		rx <= '0'; wait for 104000 ns; -- ascii A, 66, 0x0110_0001
		rx <= '1'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '1'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '0'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '0'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '1'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '1'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '0'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '1'; wait for 104000 ns; -- stop 
		rx <= '1'; wait for 104000 ns; -- stop 
	--
		rx <= '0'; wait for 104000 ns; -- start
		rx <= '1'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '0'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '1'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '0'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '0'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '1'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '1'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '0'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '1'; wait for 104000 ns; -- stop 
		rx <= '1'; wait for 104000 ns; -- stop 
		wait;
	end process;

	-- Instantiate the Unit Under Test (UUT)
   uut: uart_rx PORT MAP (
          clk => clk,
          rst => rst,
          rx => rx,
          rx_data => rx_data 
        );
END;

