LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY tb_bench IS
END tb_bench;
 
ARCHITECTURE behavior OF tb_bench IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT uart
    PORT(
         clk : IN  std_logic;
         rst : IN  std_logic;
         rx : IN  std_logic;
         tx : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal rst : std_logic := '0';
   signal rx : std_logic := '1';

 	--Outputs
   signal tx : std_logic;


 
BEGIN
 	clk <= not clk after 5 ns;
	rst <= '1' after 100 ns;

	process
	begin
		wait for 114000 ns;
		--
		rx <= '0'; wait for 104000 ns; -- start
		rx <= '1'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '0'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '0'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '0'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '0'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '1'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '1'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '0'; wait for 104000 ns; -- ascii A, 61, 
		rx <= '1'; wait for 104000 ns; -- stop 
		rx <= '1'; wait for 104000 ns; -- stop 
	--
		rx <= '0'; wait for 104000 ns; -- start
		rx <= '0'; wait for 104000 ns; -- ascii A, 61, 0x0110_0001
		rx <= '1'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '1'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '0'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '0'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '1'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '1'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '0'; wait for 104000 ns; -- ascii B, 66, 0x0110_0110
		rx <= '1'; wait for 104000 ns; -- stop 
		rx <= '1'; wait for 104000 ns; -- stop 
	--
		rx <= '0'; wait for 104000 ns; -- start
		rx <= '1'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '0'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '1'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '0'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '0'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '1'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '1'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '0'; wait for 104000 ns; -- ascii A, 65, 0x0110_0101
		rx <= '1'; wait for 104000 ns; -- stop 
		rx <= '1'; wait for 104000 ns; -- stop 
		wait;
	end process;

	-- Instantiate the Unit Under Test (UUT)
   uut: uart PORT MAP (
          clk => clk,
          rst => rst,
          rx => rx,
          tx => tx
        );
END;

