library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity uart_rx_tx is
	port (
		clk : in std_logic;
		rst : in std_logic;
		rx : in std_logic;
		tx : out std_logic);
end uart_rx_tx;

architecture Behavioral of uart_rx_tx is
	signal tick, ready, ack : std_logic;
	signal cnt : integer range 0 to 651; 
	signal uart_data : std_logic_vector(7 downto 0);
begin
	Inst_uart_rx: entity work.uart_rx PORT MAP(
		clk => clk,
		rst => rst,
		tick => tick,
		ready => ready,
		ack => ack,
		dout => uart_data,
		rx => rx 
	);

	Inst_uart_tx: entity work.uart_tx PORT MAP(
		clk => clk,
		rst => rst,
		tick => tick,
		ready => ready,
		ack => ack,
		din => uart_data,
		tx => tx 
	);

	make_tick : process(clk)
	begin
		if clk'event and clk = '1' then
			if cnt = 651 then
				tick <= '1';
				cnt <= 0; 
			else
				tick <= '0';
				cnt <= cnt + 1;
			end if;
		end if;
	end process make_tick;

end Behavioral;

