LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY tb_bench IS
END tb_bench;
 
ARCHITECTURE behavior OF tb_bench IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT top
    PORT(
         sw0 : IN  std_logic;
         sw1 : IN  std_logic;
         int_req : OUT  std_logic_vector(1 downto 0);
         clk : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal sw0 : std_logic := '1';
   signal sw1 : std_logic := '1';
   signal clk : std_logic := '0';

 	--Outputs
   signal int_req : std_logic_vector(1 downto 0);

   -- Clock period definitions
   constant clk_period : time := 1us;
 
BEGIN
 
	clk <= not clk after 10 ns;
	-- Instantiate the Unit Under Test (UUT)
   uut: top PORT MAP (
          sw0 => sw0,
          sw1 => sw1,
          int_req => int_req,
          clk => clk
        );

	process
	begin
		wait for 1 us;
		-- chattering 1 to 0
		for i in 0 to 60 loop 
			wait until clk'event and clk = '1'; sw0 <= '0';
			wait until clk'event and clk = '1'; sw0 <= '0';
			wait until clk'event and clk = '1'; sw0 <= '0';
			wait until clk'event and clk = '1'; sw0 <= '0';
			wait until clk'event and clk = '1'; sw0 <= '1';
			wait until clk'event and clk = '1'; sw0 <= '1';
			wait until clk'event and clk = '1'; sw0 <= '1';
			wait until clk'event and clk = '1'; sw0 <= '1';
		end loop;
		wait until clk'event and clk = '1'; sw0 <= '0';
		
		-- delay
		wait for 10 us;

		-- chattering 0 to 1
		for i in 0 to 60 loop 
			wait until clk'event and clk = '1'; sw0 <= '1';
			wait until clk'event and clk = '1'; sw0 <= '1';
			wait until clk'event and clk = '1'; sw0 <= '1';
			wait until clk'event and clk = '1'; sw0 <= '1';
			wait until clk'event and clk = '1'; sw0 <= '0';
			wait until clk'event and clk = '1'; sw0 <= '0';
			wait until clk'event and clk = '1'; sw0 <= '0';
			wait until clk'event and clk = '1'; sw0 <= '0';
		end loop;
		wait until clk'event and clk = '1'; sw0 <= '1';
		wait;
	end process;
END;

