LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY tb_uart_tx IS
END tb_uart_tx;
 
ARCHITECTURE behavior OF tb_uart_tx IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT uart_tx
    PORT(
         clk : IN  std_logic;
         rst : IN  std_logic;
         ready : IN  std_logic;
         din : IN  std_logic_vector(7 downto 0);
         tx : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal rst : std_logic := '0';
   signal ready : std_logic := '1';
   signal din : std_logic_vector(7 downto 0) := x"96"; 

 	--Outputs
   signal tx : std_logic;
BEGIN

	clk <= not clk after 5 ns;
	rst <= '1' after 10 us;
 
	-- Instantiate the Unit Under Test (UUT)
   uut: uart_tx PORT MAP (
          clk => clk,
          rst => rst,
          ready => ready,
          din => din,
          tx => tx
        );
END;

